
$(areaName)CleanFiles :=

archive :=
progs :=
cprog :=

##############################################################################
# Area Archive Section
##############################################################################

ifdef archSrc
archive := $(libdir)/$(LIBPFX)$(areaName).$(LIBSFX)
libarchive := $(libdir)/$(areaName).lib
exparchive := $(libdir)/$(areaName).exp

archObjs := $(addprefix $(objdir)/,$(addsuffix .o,$(basename $(notdir $(archSrc)))))

.SECONDARY: $(archObjs)


$(notdir $(archive))Objs := $(archObjs)
$(notdir $(archive))LDFlags := $(areaLDFlags)
ifdef archiveDoesntNeedLibs
$(notdir $(archive))Libs := 
else
$(notdir $(archive))Libs := $(patsubst %,$(LINKLIBARG)%$(LINKLIBSFX),$(dependentMods))
endif

$(areaName)CleanFiles += $(archObjs) $(archive) $(libarchive) $(exparchive)

$(archObjs): $(FORCE)

$(archObjs): AreaName = $(areaName)

$(archive): $(archObjs) $(FORCE)
	@echo _____________________________________________________________
	@echo Updating Dynamic Library $(@F)
	$(SHLINKER) $(SHLKFLAG) $($(@F)Objs) $(LINKDIRARG)$(libdir) $($(@F)Libs) $(LDFLAGS) $($(@F)LDFlags) $(SHLNAMEARG)$(libdir)/$(@F)

endif  # ifdef archSrc


##############################################################################
# Area Program Section
##############################################################################

ifdef progSrc
progs := $(addprefix $(exedir)/,$(addsuffix .exe,$(basename $(notdir $(progSrc)))))
pobjs := $(addprefix $(objdir)/,$(addsuffix .o,$(basename $(notdir $(progSrc)))))
.SECONDARY: $(pobjs)
$(pobjs): AreaName = $(areaName)

$(areaName)CleanFiles += $(progs) $(pobjs)

$(progs:.exe=.o): $(FORCE)
$(progs): $(FORCE)

endif # ifdef progSrc

ifdef complexProgram
cprog := $(exedir)/$(complexProgram).exe
pobjs := $(addprefix $(objdir)/,$(addsuffix .o,$(basename $(programFiles))))
$(pobjs): AreaName = $(areaName)
$(cprog): $(pobjs)
pobjs += $(cprog)
.SECONDARY: $(pobjs)
$(areaName)CleanFiles += $(pobjs)
endif

dep := $(objdir)/$(areaName).d
$(dep): $(archSrc) $(progSrc) $(filter-out moc_%.cpp,$(programFiles))

ifeq ("$(cleanGoal)","")
include $(dep)
endif


##############################################################################
# Area Permanent Variables Section
##############################################################################


ifdef archSrc
$(areaName)ExeLibs := $(patsubst %,$(LINKLIBARG)%$(LINKLIBSFX),$(areaName) $(dependentMods))
else
$(areaName)ExeLibs := $(patsubst %,$(LINKLIBARG)%$(LINKLIBSFX),$(dependentMods))
endif
$(areaName)ExeLibs += $(areaLDFlags)

##############################################################################
# Area Target Section
##############################################################################

.PHONY: $(areaName) $(areaName)All $(areaName)Force $(areaName)Clean $(areaName)Tree

$(areaName): $(archive) $(progs) $(cprog)

$(areaName)All: $(areaName)

$(areaName)Force:
	$(MAKE) $(patsubst %Force,%,$@) FORCE=true

$(areaName)Clean:
	-rm -f $($(patsubst %Clean,%,$@)CleanFiles)

$(areaName)Tree: $(addsuffix Tree,$(dependentMods)) $(areaName)

areaLDFlags :=
progSrc :=
archSrc :=
complexProgram :=
programFiles :=
