/*****************************************************************************
 * SGL: A Scene Graph Library
 *
 * Copyright (C) 1997-2001  Scott McMillan   All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************
 *     File: sglLODState.cpp
 *  Created: 7 April 1999
 *  Summary: Used to modify the transition behaviour of groups of sglLOD nodes
 *****************************************************************************/

#include <sglLODState.hpp>

//----------------------------------------------------------------------------
sglLODState::sglLODState()
      : sglObject(),
        m_range_scale(1.0f),
        m_range_offset(0.0f)
{
}

//----------------------------------------------------------------------------
sglLODState::~sglLODState()
{
}

//----------------------------------------------------------------------------
void sglLODState::printInfo(ostream &ostrm, const char *indent_string) const
{
    sglObject::printInfo(ostrm, indent_string);
    ostrm << indent_string << "scale = " << m_range_scale << ", offset = "
          << m_range_offset << endl;
}
