/*****************************************************************************
 * SGL: A Scene Graph Library
 *
 * Copyright (C) 1997-2001  Scott McMillan   All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************
 *     File: sglLineStripSet.hpp
 *  Created: 12 August 1997
 *  Summary: Approximates a pfGeoSet which contains geometry data for a set of
 *         : line strips, and pointers to the graphics state associated with
 *         : it (sglGeoState).
 *****************************************************************************/

#ifndef __SGL_LINE_STRIP_SET_HPP
#define __SGL_LINE_STRIP_SET_HPP

#include <sgl.h>
#include <sglGeoStripSet.hpp>

//============================================================================

/** contains geometry data for a set of line strips
 */

class SGL_DLL_API sglLineStripSet : public sglGeoStripSet
{
public:
   /// default constructor
   sglLineStripSet();
   /// virtual destructor
   virtual ~sglLineStripSet();

   /// retrieve the type of primitive
   sglStats::PrimEnum getPrimType() const {return sglStats::eLINESTRIPS;}
   ///
   GLenum getGLPrimType() const {return GL_LINE_STRIP;}
   ///
   AAEnum getAAType() const {return eLINE_AA;}

private: // not implemented
   sglLineStripSet(const sglLineStripSet &);
   sglLineStripSet &operator=(const sglLineStripSet &);
};

#endif
