/*****************************************************************************
 * SGL: A Scene Graph Library
 *
 * Copyright (C) 1997-2001  Scott McMillan   All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************
 *     File: sglMonoIndexedLineSet.hpp
 *  Created: 28 August 1999
 *  Summary: A sglMonoIndexedSet of lines.
 *****************************************************************************/

#ifndef __SGL_MONO_INDEXED_LINE_SET_HPP
#define __SGL_MONO_INDEXED_LINE_SET_HPP

#include <sgl.h>
#include <sglMonoIndexedGeoSet.hpp>

//============================================================================

/** geometry data for lines that use single index list for all attributes
 */

class SGL_DLL_API sglMonoIndexedLineSet : public sglMonoIndexedGeoSet
{
public:
   /// default constructor
   sglMonoIndexedLineSet();
   /// virtual destructor
   virtual ~sglMonoIndexedLineSet();

   /// retrieve the type of primitive
   sglStats::PrimEnum getPrimType() const {return sglStats::eMONO_INDEXED_LINES;}
   ///
   GLenum getGLPrimType() const {return GL_LINES;}
   ///
   unsigned int getPrimSize() const {return 2;}
   ///
   AAEnum getAAType() const {return eLINE_AA;}

private: // not implemented
   sglMonoIndexedLineSet(const sglMonoIndexedLineSet &);
   sglMonoIndexedLineSet &operator=(const sglMonoIndexedLineSet &);
};

#endif
