/*****************************************************************************
 * SGL: A Scene Graph Library
 *
 * Copyright (C) 1997-2001  Scott McMillan   All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************
 *     File: sglMonoIndexedQuadSet.hpp
 *  Created: 28 August 1999
 *  Summary: A sglMonoIndexedSet of quads.
 *****************************************************************************/

#ifndef __SGL_MONO_INDEXED_QUAD_SET_HPP
#define __SGL_MONO_INDEXED_QUAD_SET_HPP

#include <sgl.h>
#include <sglMonoIndexedGeoSet.hpp>

//============================================================================

/** geometry data for quads that use a single index list for all attributes
 */

class SGL_DLL_API sglMonoIndexedQuadSet : public sglMonoIndexedGeoSet
{
public:
   /// default constructor
   sglMonoIndexedQuadSet();
   /// virtual destructor
   virtual ~sglMonoIndexedQuadSet();

   /// retrieve the type of primitive
   sglStats::PrimEnum getPrimType() const {return sglStats::eMONO_INDEXED_QUADS;}
   ///
   GLenum getGLPrimType() const {return GL_QUADS;}
   ///
   unsigned int getPrimSize() const {return 4;}
   ///
   AAEnum getAAType() const {return ePOLYGON_AA;}

   ///
   virtual sglBound::IntersectResultEnum intersectPrim(sglIntersectf &segset);
   ///
   virtual sglBound::IntersectResultEnum intersectPrim(sglIntersectd &segset);

private: // not implemented
   sglMonoIndexedQuadSet(const sglMonoIndexedQuadSet &);
   sglMonoIndexedQuadSet &operator=(const sglMonoIndexedQuadSet &);
};

#endif
