/*****************************************************************************
 * SGL: A Scene Graph Library
 *
 * Copyright (C) 1997-2001  Scott McMillan   All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************
 *     File: sglMonoIndexedQuadStripSet.hpp
 *  Created: 28 August 1999
 *  Summary: A sglMonoIndexedSet of quadStrips.
 *****************************************************************************/

#ifndef __SGL_MONO_INDEXED_QUAD_STRIP_SET_HPP
#define __SGL_MONO_INDEXED_QUAD_STRIP_SET_HPP

#include <sgl.h>
#include <sglMonoIndexedGeoStripSet.hpp>

//============================================================================

/** geometry data for quad strips that use single index list for all attributes
 */

class SGL_DLL_API sglMonoIndexedQuadStripSet : public sglMonoIndexedGeoStripSet
{
public:
   /// default constructor
   sglMonoIndexedQuadStripSet();
   /// virtual destructor
   virtual ~sglMonoIndexedQuadStripSet();

   /// retrieve the type of primitive
   sglStats::PrimEnum getPrimType() const {return sglStats::eMONO_INDEXED_QUADSTRIPS;}
   ///
   GLenum getGLPrimType() const {return GL_QUAD_STRIP;}
   ///
   AAEnum getAAType() const {return ePOLYGON_AA;}

   ///
   virtual sglBound::IntersectResultEnum intersectPrim(sglIntersectf &segset);
   ///
   virtual sglBound::IntersectResultEnum intersectPrim(sglIntersectd &segset);

private: // not implemented
   sglMonoIndexedQuadStripSet(const sglMonoIndexedQuadStripSet &);
   sglMonoIndexedQuadStripSet &operator=(const sglMonoIndexedQuadStripSet &);
};

#endif
