/*****************************************************************************
 * SGL: A Scene Graph Library
 *
 * Copyright (C) 1997-2001  Scott McMillan   All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************
 *     File: sglMonoIndexedTriangleFanSet.hpp
 *  Created: 28 August 1999
 *  Summary: A sglMonoIndexedSet of triangleFans.
 *****************************************************************************/

#ifndef __SGL_MONO_INDEXED_TRIANGLE_FAN_SET_HPP
#define __SGL_MONO_INDEXED_TRIANGLE_FAN_SET_HPP

#include <sgl.h>
#include <sglMonoIndexedGeoStripSet.hpp>

//============================================================================

/** geometry data for triangle fans that use a single index list for all the
    attributes.
*/

class SGL_DLL_API sglMonoIndexedTriangleFanSet : 
    public sglMonoIndexedGeoStripSet
{
public:
   /// default constructor
   sglMonoIndexedTriangleFanSet();
   /// virtual destructor
   virtual ~sglMonoIndexedTriangleFanSet();

   /// retrieve the type of primitive
   sglStats::PrimEnum getPrimType() const {return sglStats::eMONO_INDEXED_TRIFANS;}
   ///
   GLenum getGLPrimType() const {return GL_TRIANGLE_FAN;}
   ///
   AAEnum getAAType() const {return ePOLYGON_AA;}

   ///
   virtual sglBound::IntersectResultEnum intersectPrim(sglIntersectf &segset);
   ///
   virtual sglBound::IntersectResultEnum intersectPrim(sglIntersectd &segset);

private: // not implemented
   sglMonoIndexedTriangleFanSet(const sglMonoIndexedTriangleFanSet &);
   sglMonoIndexedTriangleFanSet &operator=(
                                const sglMonoIndexedTriangleFanSet &);
};

#endif
