/*****************************************************************************
 * SGL: A Scene Graph Library
 *
 * Copyright (C) 1997-2001  Scott McMillan   All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************
 *     File: sglPointSet.hpp
 *  Created: 22 October 1997
 *  Summary: Approximates a pfGeoSet which contains geometry data for a set of
 *         : points, and pointers to the graphics state associated with it
 *         : (sglGeoState).
 *****************************************************************************/

#ifndef __SGL_POINT_SET_HPP
#define __SGL_POINT_SET_HPP

#include <sgl.h>
#include <sglGeoSet.hpp>

//============================================================================

/** contains geometry data for individual points.
 */

class SGL_DLL_API sglPointSet : public sglGeoSet
{
public:
   /// default constructor
   sglPointSet();
   /// virtual destructor
   virtual ~sglPointSet();

   /// retrieve the primitive type
   sglStats::PrimEnum getPrimType() const {return sglStats::ePOINTS;}
   ///
   GLenum getGLPrimType() const {return GL_POINTS;}
   ///
   unsigned int getPrimSize() const {return 1;}
   ///
   AAEnum getAAType() const {return ePOINT_AA;}

private: // not implemented
   sglPointSet(const sglPointSet &);
   sglPointSet &operator=(const sglPointSet &);
};

#endif
