/*****************************************************************************
 * SGL: A Scene Graph Library
 *
 * Copyright (C) 1997-2001  Scott McMillan   All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************
 *     File: sglVector.hpp
 *  Created: 2 January 1999
 *  Summary: 2D, 3D, and 4D vector classes
 *****************************************************************************/

#ifndef __SGL_VECTOR_HPP
#define __SGL_VECTOR_HPP

#include <sgl.h>

#include <sglVec2.hpp>
#include <sglVec3.hpp>
#include <sglVec4.hpp>

// ---------------------------------------------------------------------------
// convenience types
// ---------------------------------------------------------------------------

typedef sglVec2<float>  sglVec2f;
typedef sglVec2<double> sglVec2d;
typedef sglVec3<float>  sglVec3f;
typedef sglVec3<double> sglVec3d;
typedef sglVec4<float>  sglVec4f;
typedef sglVec4<double> sglVec4d;

// ===========================================================================

#endif
