/*****************************************************************************
 * SGL: A Scene Graph Library
 *
 * Copyright (C) 1997-2001  Scott McMillan   All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************
 *     File: sglAxes.hpp
 *   Author: Scott McMillan
 *  Created: 23 January 2001
 *  Summary: an leaf sglNode containing the geometry for coordinate axes.  The
 *           red line is the X axis, green - Y, and blue - Z.
 *****************************************************************************/

#ifndef SGL_AXES_HPP
#define SGL_AXES_HPP

#include <sgldb.h>
#include <sglLineSet.hpp>

//----------------------------------------------------------------------------

class SGLDB_DLL_API sglAxes : public sglLineSet
{
public:
   sglAxes(float size = 1.0f);
   virtual ~sglAxes();

   virtual void printInfo(ostream &ostrm, const char *indent_string) const;

private:
   sglAxes(const sglAxes &);            // not implemented
   sglAxes &operator=(const sglAxes &); // not implemented

   void makeCoordinateAxes(float size);

private:
   float            m_size;
};

#endif
