/*****************************************************************************
 * SGL: A Scene Graph Library
 *
 * Copyright (C) 1997-2001  Scott McMillan   All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************
 *     File: sglCube.hpp
 *   Author: Scott McMillan
 *  Created: 23 January 2001
 *  Summary: an leaf sglNode containing the geometry for cube (actually an
 *           axis-aligned rectangular solid) whose origin is the center of the
 *           solid.
 *****************************************************************************/

#ifndef SGL_CUBE_HPP
#define SGL_CUBE_HPP

#include <sgldb.h>
#include <sglQuadSet.hpp>

//----------------------------------------------------------------------------

class SGLDB_DLL_API sglCube : public sglQuadSet
{
public:
   sglCube(float size_x = 1.0f, float size_y = 1.0f, float size_z = 1.0f);
   sglCube(const sglVec3f &size);
   virtual ~sglCube();

   virtual void printInfo(ostream &ostrm, const char *indent_string) const;

private:
   sglCube(const sglCube &);            // not implemented
   sglCube &operator=(const sglCube &); // not implemented

   void makeCube(const sglVec3f &size);

private:
   sglVec3f    m_size;
};

#endif
