/*****************************************************************************
 * SGL: A Scene Graph Library
 *
 * Copyright (C) 1997-2001  Scott McMillan   All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************
 *     File: sglLoadImage_tga.hpp
 *   Author: Mike Morrison
 *  Created: March 2002
 *  Summary: read Certain TGA format images
 *****************************************************************************/

#ifndef __SGL_LOAD_IMAGE_TGA_HPP
#define __SGL_LOAD_IMAGE_TGA_HPP

#include <sgldb.h>
#include <sglTexture.hpp>

// Helper function to load a .tga file.
// Returns a pointer to the data and sets the number of components and size
// parameters.  Will return NULL if there was a problem loading the image
extern "C"
{
   SGLDB_DLL_API void *loadImageTGA(const string &filepath,
                                    unsigned int &width,
                                    unsigned int &height,
                                    sglTexture::ExternalFormatEnum &format,
                                    sglTexture::TypeEnum &type);
}

#endif
