/*****************************************************************************
 * SGL: A Scene Graph Library
 *
 * Copyright (C) 1997-2001  Scott McMillan   All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************
 *     File: sglSphere.hpp
 *   Author: Scott McMillan
 *  Created: 23 January 2001
 *  Summary: an leaf sglNode containing the geometry a sphere with origin at
 *           the center.
 *****************************************************************************/

#ifndef SGL_SPHERE_HPP
#define SGL_SPHERE_HPP

#include <sgldb.h>
#include <sglMonoIndexedTriangleStripSet.hpp>

//----------------------------------------------------------------------------

class SGLDB_DLL_API sglSphere : public sglMonoIndexedTriangleStripSet
{
public:
   sglSphere(unsigned int num_slices, unsigned int num_stacks,
             float radius = 1.0f);
   virtual ~sglSphere();

   virtual void printInfo(ostream &ostrm, const char *indent_string) const;

protected:

private:
   sglSphere();                             // not implemented
   sglSphere(const sglSphere &);            // not implemented
   sglSphere &operator=(const sglSphere &); // not implemented

   void makeSphere(unsigned int num_slices, unsigned int num_stacks,
                   float radius);

private:
   unsigned int         m_num_slices, m_num_stacks;
   float                m_radius;
};

#endif
