/*****************************************************************************
 * SGL: A Scene Graph Library
 *
 * Copyright (C) 1997-2001  Scott McMillan   All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************
 *     File: sglVertStruct.cpp
 *  Project: obj loader/stripifier/morphing
 *  Created: 17 July 1997
 *  Summary: vertStruct objects
 *****************************************************************************/

#include <sglVertStruct.hpp>


ostream& operator<<(ostream& ostrm, const sglVertStructVNTC& vert)
{
    return ostrm << "        vi, ni, ti, ci: " << vert.vi << ' ' << vert.ni
         << ' ' << vert.ti << ' ' << vert.ci << endl;
}

ostream& operator<<(ostream& ostrm, const sglVertStructVNT& vert)
{
    return ostrm << "        vi, ni, ti: " << vert.vi << ' ' << vert.ni
         << ' ' << vert.ti << endl;
}

ostream& operator<<(ostream& ostrm, const sglVertStructVNC& vert)
{
    return ostrm << "        vi, ni, ci: " << vert.vi << ' ' << vert.ni
                 << ' ' << vert.ci << endl;
}

ostream& operator<<(ostream& ostrm, const sglVertStructVN& vert)
{
    return ostrm << "        vi, ni: " << vert.vi << ' ' << vert.ni << endl;
}

ostream& operator<<(ostream& ostrm, const sglVertStructVTC& vert)
{
    return ostrm << "        vi, ti, ci: " << vert.vi << ' ' << vert.ti
                 << ' ' << vert.ci << endl;
}

ostream& operator<<(ostream& ostrm, const sglVertStructVT& vert)
{
    return ostrm << "        vi, ti: " << vert.vi << ' ' << vert.ti << endl;
}

ostream& operator<<(ostream& ostrm, const sglVertStructVC& vert)
{
    return ostrm << "        vi, ci: " << vert.vi << ' ' << vert.ci << endl;
}

ostream& operator<<(ostream& ostrm, const sglVertStructV& vert)
{
    return ostrm << "        vi: " << vert.vi << endl;
}

bool operator==(const sglVertStructV& lhs, const sglVertStructV& rhs)
{
    return lhs.vi == rhs.vi;
}

bool operator==(const sglVertStructVC& lhs, const sglVertStructVC& rhs)
{
    return lhs.vi == rhs.vi && lhs.ci == rhs.ci;
}

bool operator==(const sglVertStructVN& lhs, const sglVertStructVN& rhs)
{
    return lhs.vi == rhs.vi && lhs.ni == rhs.ni;
}

bool operator==(const sglVertStructVNC& lhs, const sglVertStructVNC& rhs)
{
    return lhs.vi == rhs.vi && lhs.ni == rhs.ni && lhs.ci == rhs.ci;
}

bool operator==(const sglVertStructVT& lhs, const sglVertStructVT& rhs)
{
    return lhs.vi == rhs.vi && lhs.ti == rhs.ti;
}

bool operator==(const sglVertStructVTC& lhs, const sglVertStructVTC& rhs)
{
    return lhs.vi == rhs.vi && lhs.ti == rhs.ti && lhs.ci == rhs.ci;
}

bool operator==(const sglVertStructVNT& lhs, const sglVertStructVNT& rhs)
{
    return lhs.vi == rhs.vi && lhs.ni == rhs.ni && lhs.ti == rhs.ti;
}

bool operator==(const sglVertStructVNTC& lhs, const sglVertStructVNTC& rhs)
{
    return lhs.vi == rhs.vi && lhs.ni == rhs.ni
        && lhs.ti == rhs.ti && lhs.ci == rhs.ci;
}

