/*****************************************************************************
 * SGL: A Scene Graph Library
 *
 * Copyright (C) 1997-2001  Scott McMillan   All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************
 *     File: sgldb.h
 *  Project: 9 September 1999
 *  Summary: SGL database library....miscellaneous file loaders (models/images)
 *****************************************************************************/

#ifndef __SGLDB_H
#define __SGLDB_H

#if defined(WIN32) && defined(_DLL)
// The next define will come from the makefile for archive objects.
#ifdef sgldb_DLL_FILE
#define SGLDB_DLL_API __declspec(dllexport)
#else
#define SGLDB_DLL_API __declspec(dllimport)
#endif
#else
#define SGLDB_DLL_API
#endif

#include <sgl.h>

#if defined(linux)
#include <endian.h>
#endif

#if defined(WIN32) || (defined(sgi) && defined(unix) && defined(_MIPSEL)) || (defined(sun) && defined(unix) && !defined(_BIG_ENDIAN)) || (defined(__BYTE_ORDER) && (__BYTE_ORDER == __LITTLE_ENDIAN)) || (defined(__APPLE__) && defined( __LITTLE_ENDIAN__ ))
#  define SGL_LITTLE_ENDIAN
#elif (defined(sgi) && defined(unix) && defined(_MIPSEB)) || (defined(sun) && defined(unix) && defined(_BIG_ENDIAN)) || defined(vxw) || (defined(__BYTE_ORDER) && (__BYTE_ORDER == __BIG_ENDIAN)) || (defined(__APPLE__) && defined( __BIG_ENDIAN__) )
#  define SGL_BIG_ENDIAN
#else
#  error unknown endian type
#endif

static inline void sglEndianSwap(unsigned int *x)
{
   *x = (( *x >> 24 ) & 0x000000FF ) | 
        (( *x >>  8 ) & 0x0000FF00 ) | 
        (( *x <<  8 ) & 0x00FF0000 ) | 
        (( *x << 24 ) & 0xFF000000 ) ;
}

static inline void sglEndianSwap(int *x)
{
   *x = (( *x >> 24 ) & 0x000000FF ) | 
        (( *x >>  8 ) & 0x0000FF00 ) | 
        (( *x <<  8 ) & 0x00FF0000 ) | 
        (( *x << 24 ) & 0xFF000000 ) ;
}

static inline void sglEndianSwap(unsigned short *x)
{
   *x = (( *x >>  8 ) & 0x00FF ) | 
        (( *x <<  8 ) & 0xFF00 ) ;
}

static inline void sglEndianSwap(short *x)
{
   *x = (( *x >>  8 ) & 0x00FF ) | 
        (( *x <<  8 ) & 0xFF00 ) ;
}

#endif
