/*****************************************************************************
 * SGL: A Scene Graph Library
 *
 * Copyright (C) 1997-2001  Scott McMillan   All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************
 *     File: sglLoadImage_png.hpp
 *   Author: Tom Stimson
 *  Created: February 2002
 *  Summary: read PNG format images using external library
 *****************************************************************************/

#ifndef __SGL_LOAD_IMAGE_PNG_HPP
#define __SGL_LOAD_IMAGE_PNG_HPP

#include <sglpng.h>
#include <sglTexture.hpp>

// Helper function to load a .png file.
// Returns a pointer to the data and sets the number of components and size
// parameters.  Will return NULL if there was a problem loading the image
extern "C"
{
   SGLPNG_DLL_API void *loadImagePNG(const string &filepath,
                                     unsigned int &width,
                                     unsigned int &height,
                                     sglTexture::ExternalFormatEnum &format,
                                     sglTexture::TypeEnum &type);
}

// Helper function to write a .png file.
// Returns false if an error occured while writing the file.
extern "C"
{
   SGLPNG_DLL_API bool writeImagePNG(const string &filepath,
                                     const void *image,
                                     unsigned int width,
                                     unsigned int height,
                                     sglTexture::ExternalFormatEnum format,
                                     sglTexture::TypeEnum type);
}

#endif
