/*****************************************************************************
 * SGL: A Scene Graph Library
 *
 * Copyright (C) 1997-2001  Scott McMillan   All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************
 *     File: sglTrPageTest.hpp
 *   Author: Bryan Walsh
 *  Created: 19 October 2001
 *  Summary: Terrex terrain page loader unit test for SGL
 *****************************************************************************/

#ifndef __SGL_TRPAGE_TEST_HPP
#define __SGL_TRPAGE_TEST_HPP

#include <sglLoadFile_txp.hpp>
#include <string>

class trpgr_Archive;

//----------------------------------------------------------------------------
/**
   This class unit tests the TerraPage parser.  The user may instantiate
   one of these classes explicitly and call the testLoader member function to
   test an archive.  See the testTXPParser.cpp test program for an example of
   its use.
*/

class SGLTXP_DLL_API sglTrPageTest
{
public:
   /// constructor.
   sglTrPageTest();
   /// virtual destructor.
   virtual ~sglTrPageTest();

   /** Test the Terrex Terrain Page loader.
       @param filename Filename of the *.txp file (optionally with path).
   */
   bool testLoader(const std::string &filepath);

private: // not implemented
   sglTrPageTest(const sglTrPageTest &);
   sglTrPageTest &operator=(const sglTrPageTest &);

private:
   bool testHeader(trpgr_Archive &archive);
   bool testTiles(trpgr_Archive &archive);
};

#endif
