/*****************************************************************************
 * SGL: A Scene Graph Library
 *
 * Copyright (C) 1997-2001  Scott McMillan   All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * Copyright 1999, Scott McMillan
 *****************************************************************************
 *  File: testTXPParser.cpp
 *  Author: Bryan Walsh
 *  Created: 19 October 2001
 *  Summary: test Terrex .txp parser
 *****************************************************************************/

#include <GL/glut.h>
#include <sgl.h>
#include <sglOStream.hpp>
#include <sglDataLoader.hpp>
#include <sglTrPageTest.hpp>

//----------------------------------------------------------------------------
void testModelTXP(const string &filepath)
{
   sglTrPageTest test;
   test.testLoader(filepath);
}

//----------------------------------------------------------------------------
int main(int argc, char** argv)
{
   glutInit(&argc, argv);

   //=========================
   if (argc < 2)
   {
      cerr << "Usage: " << argv[0] << " <filename>." << endl;
      exit(1);
   }
   glutInitWindowSize(700, 512);
   glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
   glutCreateWindow("sglfly");

   sgl::initialize();

   sglOStream::setThreshold(sglOStream::eINFO);

   vector<string> data_path;
   data_path.push_back(".");
   data_path.push_back("./models");
   data_path.push_back("../models");
   sglDataLoader::setDataPath(data_path);

   string filename;

   if (sglDataLoader::findFile(argv[1], NULL, filename))
      testModelTXP(filename);
   else
      testModelTXP(argv[1]);

   return 0;             /* ANSI C requires main to return int. */
}
