
#include <iostream.h>
#include <sglVec3.hpp>
#include <sglVec2.hpp>
#include <vector>

class Unique3
{
public:
	//
	// we don't currently attempt to eliminate unused
	//
	Unique3( vector<float> &vec, vector<int> &indx )
	{
		unsigned int i, j, size, elim = 0;

		size = vec.size() / 3;

		newCoords.resize( size ); 

		for(i=0;i<vec.size();i+=3)
			newCoords[i/3].set( vec[i+0], vec[i+1], vec[i+2] );

		ulist.resize( size );
		dlist.resize( size );

		// set initial entries
		for(i=0;i<size;i++)
			dlist[i] = false;

		int uniq = 0;

		for(i=0;i<size;i++)
		{
			bool found = false;

			// if deleted, skip
			if( dlist[i] )
				continue;
			else
				ulist[i] = uniq;

			for(j=i+1; j<size; j++)
			{
				// if deleted, skip
				if( dlist[j] )
					continue;

				// check for exact match for now
				if( newCoords[i] == newCoords[j] )
				{
					found = true;
					dlist[j] = true;
					ulist[j] = uniq;
					elim++;
				}
			}

			uniq++;
		}

		// copy in new coords
		vec.clear();

		for(i=0;i<size;i++)
		{
			// if deleted, skip
			if( dlist[i] )
				continue;

			vec.push_back( newCoords[i][0] ); 
			vec.push_back( newCoords[i][1] ); 
			vec.push_back( newCoords[i][2] ); 
		}

		// reset indices
		for(i=0;i<indx.size();i++)
		{
			// skip -1's in stream
			if( indx[i] == -1 )
					continue;

			indx[i] = ulist[ indx[i] ];
		}

		//cout << "Eliminated " << elim << " redundant entries from " <<size<< endl;
	}

	~Unique3( void )
	{
	}

private:
	vector<sglVec3f> newCoords;
	vector<int> dlist;
	vector<int> ulist;

};

class Unique2
{
public:
	//
	// we don't currently attempt to eliminate unused
	//
	Unique2( vector<float> &vec, vector<int> &indx )
	{
		unsigned int i, j, size, elim = 0;

		size = vec.size() / 2;

		newCoords.resize( size ); 

		for(i=0;i<vec.size();i+=2)
			newCoords[i/2].set( vec[i+0], vec[i+1] );

		ulist.resize( size );
		dlist.resize( size );

		// set initial entries
		for(i=0;i<size;i++)
			dlist[i] = false;

		int uniq = 0;

		for(i=0;i<size;i++)
		{
			bool found = false;

			// if deleted, skip
			if( dlist[i] )
				continue;
			else
				ulist[i] = uniq;

			for(j=i+1; j<size; j++)
			{
				// if deleted, skip
				if( dlist[j] )
					continue;

				// check for exact match for now
				if( newCoords[i] == newCoords[j] )
				{
					found = true;
					dlist[j] = true;
					ulist[j] = uniq;
					elim++;
				}
			}

			uniq++;
		}

		// copy in new coords
		vec.clear();

		for(i=0;i<size;i++)
		{
			// if deleted, skip
			if( dlist[i] )
				continue;

			vec.push_back( newCoords[i][0] ); 
			vec.push_back( newCoords[i][1] ); 
		}

		// reset indices
		for(i=0;i<indx.size();i++)
		{
			// skip -1's in stream
			if( indx[i] == -1 )
					continue;

			indx[i] = ulist[ indx[i] ];
		}

		//cout << "Eliminated " << elim << " redundant entries from " <<size<< endl;
	}

	~Unique2( void )
	{
	}

private:
	vector<sglVec2f> newCoords;
	vector<int> dlist;
	vector<int> ulist;

};

