/*****************************************************************************
 * SGL: A Scene Graph Library
 *
 * Copyright (C) 1997-2001  Scott McMillan   All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************
 *     File: testLineStripper.cpp
 *   Author: Tom Stimson
 *  Created: August 1999
 *  Summary: in progress
 *****************************************************************************/

#include <sgldb.h>
#include <sglLineStripper.hpp>
#include <sglVertStruct.hpp>
#include <sglOStream.hpp>

int main(int, char**)
{
   sglOStream::setStream(&cout);
   sglOStream::setThreshold(sglOStream::eDEBUG);

   sglLineStripper<sglVertStructV> stripper;

   sglVertStructV aa;
   sglVertStructV bb;

   aa.vi = 0;
   bb.vi = 1;
   stripper.addSegment(aa, bb);
   aa.vi = 4;
   bb.vi = 5;
   stripper.addSegment(aa, bb);
   aa.vi = 2;
   bb.vi = 3;
   stripper.addSegment(aa, bb);
   aa.vi = 8;
   bb.vi = 1;
   stripper.addSegment(aa, bb);
   aa.vi = 0;
   bb.vi = 7;
   stripper.addSegment(aa, bb);
   aa.vi = 5;
   bb.vi = 3;
   stripper.addSegment(aa, bb);
   aa.vi = 0;
   bb.vi = 1;
   stripper.addSegment(aa, bb);

   stripper.lineStripify();

   for (unsigned int ii = 0; ii < stripper.getNumStrips(); ++ii)
   {
      const deque<sglVertStructV>& strip = stripper.getStrip(ii);
      cerr << "Strip " << ii << ":" << endl;
      for (deque<sglVertStructV>::const_iterator jj = strip.begin();
           jj != strip.end(); ++jj)
      {
         cerr << "   " << (*jj).vi << endl;
      }
   }

   return 0;
}
