/*****************************************************************************
 * SGL: A Scene Graph Library
 *
 * Copyright (C) 1997-2001  Scott McMillan   All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *****************************************************************************
 *     File: testOStream.cpp
 *   Author: Tom Stimson
 *  Created: 8 April 2000
 *****************************************************************************/

#include <GL/glut.h>
#include <sgl.h>
#include <sglOStream.hpp>
#include <sglTransform.hpp>


void prefunc()
{
   cout << "Beginning of stream" << endl;
}

void postfunc()
{
   cout << "End of stream" << endl;
}

void testFileStream()
{
   sglPrint() << "Changing stream to file: out.txt" << endl;
   ofstream strm("out.txt");
   sglOStream::setStream(&strm);
   sglPrint() << "This should be in out.txt" << endl;

}

void testNodePrint()
{
   sglNode *tf = new sglTransformd();

   sglPrint() << "Testing print of a node pointer:" << endl;
   sglPrint() << tf << endl;
   sglPrint() << "Testing print of a node:" << endl;
   sglPrint() << *tf << endl;
}

int main(int argc, char *argv[])
{
   glutInit(&argc, argv);

   glutInitWindowSize(700, 512);
   glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
   glutCreateWindow("sglfly");

   sgl::initialize();

   sglOStream::setThreshold(sglOStream::eINFO);
   sglOStream::setPreFunc(prefunc);
   sglOStream::setPostFunc(postfunc);

   sglPrintDebug() << "DEBUG ERROR ERROR This shouldn't print." << endl;
   sglPrintInfo() << "INFO This should print." << endl;

   sglOStream::setThreshold(sglOStream::eDEBUG);

   sglPrintDebug() << "DEBUG This should print." << endl;
   sglPrintInfo() << "INFO This should print." << endl;

   testNodePrint();
   testFileStream();

   return 0;
}
